/* define DCT types */

/*
 * DCTSIZE      underlying (1d) transform size
 * DCTSIZE2     DCTSIZE squared
 */

#define DCTSIZE      (8)
#define DCTSIZE2     (DCTSIZE*DCTSIZE)

#define EIGHT_BIT_SAMPLES	/* needed in jrevdct.c */

typedef short DCTELEM;		/* must be at least 16 bits */

typedef DCTELEM DCTBLOCK[DCTSIZE2];

typedef long INT32;		/* must be at least 32 bits */

//////////////////////////////////////////////////////////////////////////
//
// iDCT functions
//
//////////////////////////////////////////////////////////////////////////

//extern void init_fdctdaan( void );        // initialize x87-double AAN fDCT
//extern void fdct_daan( short *block );    // BBMPEG's AAN-x87d fDCT

//extern void j_rev_dct(short *block);      // AAN integer forwardDCT

//extern void init_fdct_3dnow(void);        // initialize 3D-Now fDCT
//extern void fdct_3dnow(short *block);     // AAN 3D-Now fDCT (derived from BBMPEG)

//extern void fdct_mm32(short *block);      // the AP-922 standard MMX fDCT
//extern void fdct_am32(short *block);      // the AP-922 AMD!MMX fDCT

extern void idct_ap922int86(short *block);

extern void idct_int(short *block);    // MSSG MPEG-2 software codec AAN integer 
extern void init_idct_int( void );

// AP922float iDCT, Intel-SSE (P3/Cel2) Visual C++ inline-assembly listing
extern void idct_ap922float_sse(short *block);

// AP922float iDCT, standard x87 FPU, C-code listing (emulates Intel-SSE ap922float)
extern void idct_ap922float_x87(short *block);

// AP922float iDCT, AMD 3D-Now, Visual C++ inline-assembly listing
extern void idct_ap922float_3dn(short *block);

// AP922hybrid iDCT, AMD 3D-Now, Visual C++ inline-assembly listing
extern void idct_ap922hybr_3dn(short *data );

// AP922hybrid iDCT, standard x87 FPU, C-code listing
extern void idct_ap922hybr_x87(short *data );

// AP922float iDCT, standard x87 FPU, C-code listing (emulates 3DNow ap922float)
extern void idct_ap922float_amdx87( short *data ); 
