% liaor@iname.com
%
% simple Matlab 5 script for AP922 matrices,
%   (requires symbolic math library)
%
% The matrices A, P, B, D, E, F are entered below.
% The 'input matrix' X[] is a column vector.
%
%  To see the effect of a given operator, multiply the operator with X[]
%
%   example :
%      P*X
%
% EDU ap922
% EDU P*X
%  
% ans =
%  
% [ x0]
% [ x4]
% [ x1]
% [ x5]
% [ x2]
% [ x6]
% [ x3]
% [ x7]


% quick 4x4 '0' matrix
   z4 = zeros(4); 

% Form A8
   a0 = [1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1];
   a1 = [0 0 0 1; 0 0 1 0; 0 1 0 0; 1 0 0 0];
   A = [ a0 a1; a0 -a1;];

% Form P8
   p0 = [1 0 0 0; 0 0 0 0; 0 1 0 0; 0 0 0 0; 0 0 1 0; 0 0 0 0; 0 0 0 1; 0 0 0 0];
   p1 = [0 0 0 0; 1 0 0 0; 0 0 0 0; 0 1 0 0; 0 0 0 0; 0 0 1 0; 0 0 0 0; 0 0 0 1];
   P=[p0 p1];

% Form B8
   t1=sym('t1');
   t2=sym('t2'); % t1 = tan1
   t3=sym('t3');
   syms t1 t2 t3 real; % declare real variables 
   
   % we declare 'real' variables, so Matlab sets the variable's conjugate to 0.
   % Then. displaying the matrix tranpose does not include extra garbage 
   % like the 'xxx + conj()'
   
   b0 = [ 1 1 0 0; 1 -1 0 0; 0 0 1 t2; 0 0 t2 -1;];
   b1 = [ 1 t1 0 0; t1 -1 0 0; 0 0 1 t3; 0 0 t3 -1;];
   B = [ b0 z4; z4 b1;];

% Form E8
   e0=[ 1 0 0 1; 0 1 1 0; 1 0 0 -1; 0 1 -1 0];
   e1=[ 1 1 0 0; 0 0 1 1; 1 -1 0 0; 0 0 1 -1];
   E=[ e0 z4; z4 e1];

% form F8
   l4 = sym('l4');
   syms l4 real;
   f0=[ 1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1;];
   f1=[ 1 0 0 0; 0 l4 l4 0; 0 l4 -l4 0; 0 0 0 1];
   F =[ f0 z4; z4 f1;];

% form D8
   d0 = [ 1 0 0 0; 0 0 1 0; 0 1 0 0; 0 0 0 1;];
   d1 = [ 1 0 0 0; 0 0 1 0; 0 0 0 1; 0 1 0 0;];	
   D = [d0 z4; z4 d1];
   
% form input vector X

   x0=sym('x0');
   x1=sym('x1');
   x2=sym('x2');
   x3=sym('x3');
   x4=sym('x4');
   x5=sym('x5');
   x6=sym('x6');
   x7=sym('x7');
   syms x0 x1 x2 x3 x4 x5 x6 x7 real;  % declare real
   X=[x0 x1 x2 x3 x4 x5 x6 x7]';
   
% form complete iDCT
   
   idct_column_operator = (A')*(F')*(E')*(B')*(D')*(P');
   fdct_column_operator = P*(D*B*E*F)*A;


